﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormsLibrary1
{
	public partial class CustomCheckedListBox : UserControl
	{
		public CheckedListBox.ObjectCollection Items => checkedListBox.Items;
		private EventHandler _changeEvent;
		public CustomCheckedListBox()
		{
			InitializeComponent();
		}

		public void Clear()
		{
			checkedListBox.Items.Clear();
		}

		public string SelectedElement
		{
			get
			{
				if (checkedListBox.SelectedIndex > -1 && checkedListBox.GetItemChecked(checkedListBox.SelectedIndex))
				{
					return checkedListBox.SelectedItem.ToString();
				}

				return string.Empty;
			}
			set
			{
				if (checkedListBox.Items.Contains(value))
				{
					checkedListBox.SelectedItem = value;
					checkedListBox.SetItemChecked(checkedListBox.Items.IndexOf(value), true);
				}
			}
		}
		private void checkedListBox_ItemCheck(object sender, ItemCheckEventArgs e)
		{
			if (e.NewValue == CheckState.Checked && checkedListBox.CheckedItems.Count > 0)
			{
				checkedListBox.ItemCheck -= checkedListBox_ItemCheck;
				checkedListBox.SetItemChecked(checkedListBox.CheckedIndices[0], value: false);
				checkedListBox.ItemCheck += checkedListBox_ItemCheck;
			}
		}
		public void AddItem(string item)
		{
			if (item == string.Empty) return;
			checkedListBox.Items.Add(item);
		}
		private void checkedListBox_SelectedIndexChanged(object sender, EventArgs e)
		{
			_changeEvent?.Invoke(sender, e);
		}

		// Cобытие, вызываемое при смене значения
		public event EventHandler ChangeEvent
		{
			add
			{
				_changeEvent += value;
			}
			remove
			{
				_changeEvent -= value;
			}

		}
	}
}
